#include <stdio.h>
#include "java_ser.h"

test_java_ser() {
   char *name = "test_java_ser";
   double time = 10.0;
   static double x[] = { 0.0, 1.0, 2.0, 3.0, 4.0 };
   static double fx[] = { 1.0, 2.0, 3.0, 4.0, 5.0 };
   java_ser(name, time, x, fx, 5);
}

test_java_mser() {      
   char *name = "test_java_mser";
   int nt = 2;
   static double time[] = { 1.0, 2.0 };
   static double x[] = { 0.0, 1.0, 2.0, 3.0, 4.0,
                         0.0, 1.0, 2.0, 3.0, 4.00009 };
   static double fx[] = { 1.0, 2.0, 3.0, 4.0, 5.0,
                          5.0, 4.0, 3.0, 2.0, 2.0, };
   static int nx[] = { 5, 5 };
   java_mser(name, nt, time, x, fx, nx);
}

test_java_eser() {
   char *name = "test_java_eser";
   double time = 10.0;
   static double x[] = { 0.0, 1.0, 2.0, 3.0, 4.0 };
   static double fx[] = { 1.0, 2.0, 3.0, 4.0, 5.0 };
   static double ex[] = { 0.1, 0.2, 0.3, 0.1, 0.3 };
   java_eser(name, time, x, fx, ex, 5);
}

test_java_emser() {      
   char *name = "test_java_emser";
   int nt = 2;
   static double time[] = { 1.0, 2.0 };
   static double x[] = { 0.0, 1.0, 2.0, 3.0, 4.0,
                         0.0, 1.0, 2.0, 3.0, 4.00009 };
   static double fx[] = { 1.0, 2.0, 3.0, 4.0, 5.0,
                          5.0, 4.0, 3.0, 2.0, 2.0, };
   static double ex[] = { 0.0, 0.1, 0.2, 0.2, 0.3,
                                       1.0, 1.0, 0.1, 0.2, 1.0, };
   static int nx[] = { 5, 5 };
   java_emser(name, nt, time, x, fx, ex, nx);
}

test_java_cmser() {      
   char *name = "test";
   int nt = 2;
   static double time[] = { 1.0, 2.0 };
   static double x[] = { 0.0, 1.0, 2.0, 3.0, 4.0,
                         0.0, 1.0, 2.0, 3.0, 4.00009 };
   static double fx[] = { 1.0, 2.0, 3.0, 4.0, 5.0,
                          5.0, 4.0, 3.0, 2.0, 2.0, };
   static double cx[] = { 1.0, 2.0, 3.0, 4.0, 5.0,
                          5.0, 4.0, 3.0, 2.0, 2.0, };
   static int nx[] = { 5, 5 };
   java_cmser(name, nt, time, x, fx, cx, nx);
}


test_java_ser2d() {
   char *name = "test_java_ser2d";
   double time = 10.0;
   static double x[] = { 0.0, 0.0, 0.0, 1.0, 1.0, 1.0 };
   static double y[] = { 0.0, 1.0, 2.0, 0.0, 1.0, 2.0 };
   static double fx[] = { 1.0, 2.0, 2.0, 4.0, 5.0, 1.0 };
   java_ser2d(name, time, x, y, fx, 6);
}

test_java_mser2d() {      
   char *name = "test_java_mser2d";
   int nt = 2;
   static double time[] = { 1.0, 2.0 };
   static double x[] = { 0.0, 0.0, 0.0, 1.0, 1.0, 1.0,
                         0.0, 0.0, 0.0, 1.0, 1.0, 1.0 };
   static double y[] = { 0.0, 1.0, 2.0, 0.0, 1.0, 2.0,
                         0.0, 1.0, 2.0, 0.0, 1.0, 2.0 };
   static double fx[] = { 1.0, 2.0, 3.0, 4.0, 5.0, 6.0, 
                          6.0, 5.0, 4.0, 3.0, 2.0, 2.0, };
   static int nx[] = { 6, 6 };
   java_mser2d(name, nt, time, x, y, fx, nx);
}

test_java_bser2d() {
   char *name = "test";
   double time = 10.0;
   static double x[] = { 0.0, 1.0 };
   static double y[] = { 0.0, 1.0, 2.0 };
   static double fx[] = { 1.0, 2.0, 3.0, 4.0, 5.0, 1.0 };
   java_bser2d(name, time, x, 2, y, 3, fx);
   
}

test_java_bmser2d() {
   char *name = "test";
   static double time[] = { 1.0,  2.0 };
   static double x[] = { 0.0, 1.0, 0.0, 1.0, 2.0 };
   static int nx[] = { 2, 3 };
   static double y[] = { 0.0, 1.0, 2.0, 0.0, 1.0, 2.0 };
   static int ny[] = { 3, 3 };
   static double fxy[] = { 1.0, 2.0, 3.0, 4.0, 5.0, 1.0,
        1.0, 2.0, 3.0, 4.0, 5.0, 1.0, 1.0, 2.0, 3.0  };
   java_bmser2d(name, 2, time, x, nx, y, ny, fxy);
}

test_java_bbser2d() {
   char *name = "test java_bbser2d";
   double time = 10.0;
   static double bb[] = { 0.0, 1.0, 0.0, 2.0 };
   static double fxy[] = { 1.0, 2.0, 3.0, 4.0, 5.0, 1.0 };
   java_bbser2d(name, time, bb, 2, 3, fxy);
   
}

test_java_bbmser2d() {
   char *name = "test bbmser2d";
   static double time[] = { 1.0,  2.0 };
   static double bb[][4] = { 0.0, 1.0, 0.0, 2.0, 0.0, 1.0, 0.0, 2.0 };
   static int nx[] = { 2, 3 };
   static int ny[] = { 3, 3 };
   static double fxy[] = { 1.0, 2.0, 3.0, 4.0, 5.0, 1.0,
        1.0, 2.0, 3.0, 4.0, 5.0, 1.0, 1.0, 2.0, 3.0  };
   java_bbmser2d(name, 2, time, bb, nx, ny, fxy);
}

test_java_cbbmser2d() {
   char *name = "test";
   static double time[] = { 1.0,  2.0 };
   static double bb[][4] = { 0.0, 1.0, 0.0, 2.0, 0.0, 1.0, 0.0, 2.0 };
   static int nx[] = { 2, 3 };
   static int ny[] = { 3, 3 };
   static double fxy[] = { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0,
        1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0  };
   static double cxy[] = { 1.0, 2.0, 3.0, 4.0, 5.0, 1.0,
        1.0, 2.0, 3.0, 4.0, 5.0, 1.0, 1.0, 2.0, 3.0  };
   java_cbbmser2d(name, 2, time, bb, nx, ny, fxy, cxy);
}

test_java_sercon() {
   char *name = "test";
   double time = 10;
   double time2 = 20;
   
   static double x[] = { 2.5, 4.0, 2.0, 0.0, 2.0, 5.0, 
                         7.0, 8.0, 6.0, 8.0, 8.0, 6.0 };
   static double y[] = { 0.0, 2.0, 4.0, 3.0, 2.0, 2.0, 
                         1.0, 2.0, 3.0, 3.0, 5.0, 5.0 };
   static double c[] = { 0.0, 2.0, 4.0, 3.0, 2.0, 5.0, 
                         6.0, 3.0, 1.0, 2.0, 3.0, 4.0 };
   static int cl[] = { 1, 2, 3, 4, 5, -1, 6, 7, 8, -1, 9, 10, 11, 12, -1 };

   static double x2[] = { 1.0, 4.0, 5.0, 6.0, 8.0, 7.0, 5.0, 3.0, 2.0, 1.0 };
   static double y2[] = { 7.0, 5.0, 6.0, 3.0, 8.0, 0.0, 1.0, 0.0, 3.0, 4.0 };
   static int cl2[] = { 1, 2, 3, 4, 5, 6, 7, 8,  9, 10, -1 };

   java_sercon(name, time, x, y, c, 12, cl, 15);
   java_sercon(name, time2, x2, y2, y2, 10, cl2, 11);
}


test_java_vser() {
   char *name = "test";
   double time = 10;
   static double x[] = { 0.0, 1.0, 2.0, 3.0, 4.0 };
   static double y[] = { 0.0, 1.0, 2.0, 1.0, 2.0, 3.0 };
   static double r[] = { 1.0, 2.0, 1.0, 1.0, 2.0, 1.0 };
   static double t[] = { 2.0, 2.0, 3.0, 2.0, 2.0, 3.0 };
   java_vser(name, time, x, y, r, t, 6);
   
}


test_java_vmser() {
   char *name = "test";
   static double time[] = { 1.0, 2.0 };
   static double x[] = { 0.0, 1.0, 2.0, 3.0, 4.0,
                         1.0, 2.0, 3.0, 4.0, 5.0 };
   static double y[] = { 0.0, 1.0, 2.0, 1.0, 2.0, 3.0,
                         1.0, 2.0, 1.0, 2.0, 3.0, 4.0 };
   static double r[] = { 1.0, 2.0, 1.0, 1.0, 2.0, 1.0,
                         1.0, 2.0, 1.0, 1.0, 2.0, 1.0 };
   static double t[] = { 2.0, 2.0, 3.0, 2.0, 2.0, 3.0,
                         1.0, 1.0, 1.0, 1.0, 1.0, 1.0 };
   static int nx[] = { 6, 6 };
   java_vmser(name, 2, time, x, y, r, t, nx);
   
}

test_java_bbser() {
   char *name = "test_java_bbser";
   double time = 10.0;
   static double bb[] = { 0.0, 2.0 };
   static double fx[] = { 1.0, 2.0, 3.0};
   java_bbser(name, time, bb, 3, fx);
   
}

test_java_bbmser() {
   char *name = "test_java_bbmser";
   static double time[] = { 1.0,  2.0 };
   static double bb[][4] = { 0.0, 2.0, 0.0, 2.0 };
   static int nx[] = { 3, 3 };
   static double fx[] = { 1.0, 2.0, 3.0, 4.0, 5.0, 1.0 };
   java_bbmser(name, 2, time, bb, nx, fx);
}

test_java_ebbser() {
   char *name = "test_java_ebbser";
   double time = 10.0;
   static double bb[] = { 0.0, 2.0 };
   static double fx[] = { 1.0, 2.0, 3.0};
   static double ex[] = { 0.0, 1.0, 0.5};
   java_ebbser(name, time, bb, 3, fx, ex);
   
}

test_java_ebbmser() {
   char *name = "test_java_ebbmser";
   static double time[] = { 1.0,  2.0 };
   static double bb[][4] = { 0.0, 2.0, 0.0, 2.0 };
   static int nx[] = { 3, 3 };
   static double fx[] = { 1.0, 2.0, 3.0, 4.0, 5.0, 1.0 };
   static double ex[] = { 0.0, 0.5, 0.5, 0.1, 0.5, 1.0 };
   java_ebbmser(name, 2, time, bb, nx, fx, ex);
}


test_java_pser() {
   char *name = "test";
   double time = 10.0;

   static double x1[] = { 0.0, 1.0, 2.0, 3.0, 4.0 };
   static double fx1[] = { 1.0, 2.0, 3.0, 4.0, 5.0 };
   static double x2[] = { 4.0, 5.0, 6.0, 7.0, 8.0 };
   static double fx2[] = { 1.0, 2.0, 3.0, 4.0, 5.0 };

   java_pser(name, time, x1, fx1, 5, 2);

   /* Uncomment next line means that each processor calculates each time data.
    * Otherwise, each processor calculates some parts of the time data
    */
   /* time = 20.0; */
   java_pser(name, time, x2, fx2, 5, 2);
}

test_java_pser2d() {
   char *name = "test";
   double time = 10.0;

   /* each processor produce 3 x 5 data set */
   static double x1[] = { 0.0, 0.0, 0.0, 0.0, 0.0,
                          1.0, 1.0, 1.0, 1.0, 1.0,
                          2.0, 2.0, 2.0, 2.0, 2.0, };
   static double y1[] = { 0.0, 1.0, 2.0, 3.0, 4.0,
                          0.0, 1.0, 2.0, 3.0, 4.0,
                          0.0, 1.0, 2.0, 3.0, 4.0  };
   static double fxy1[] = { 1.0, 2.0, 3.0, 4.0, 5.0,
                            1.0, 2.0, 3.0, 3.0, 3.0,
                            1.0, 2.0, 3.0, 4.0, 5.0 };

   static double x2[] = { 2.0, 2.0, 2.0, 2.0, 2.0,
                          3.0, 3.0, 3.0, 3.0, 3.0,
                          4.0, 4.0, 4.0, 4.0, 4.0 };
   static double y2[] = { 0.0, 1.0, 2.0, 3.0, 4.0,
                          0.0, 1.0, 2.0, 3.0, 4.0,
                          0.0, 1.0, 2.0, 3.0, 4.0  };
   static double fxy2[] = { 1.0, 2.0, 3.0, 4.0, 5.0,
                            2.0, 2.0, 2.0, 1.0, 1.0,
                            1.0, 2.0, 2.0, 2.0, 3.0 };

   java_pser2d(name, time, x1, y1, fxy1, 15, 2);

   /* Uncomment next line means that each processor calculates each time data.
    * Otherwise, each processor calculates some parts of the time data
    */
   time = 20.0; 
   java_pser2d(name, time, x2, y2, fxy2, 15, 2);
}


test_java_pbbser2d() {
   char *name = "test";
   double time = 10.0;
   static double bb1[] = { 0.0, 2.0, 0.0, 4.0 };
   static double bb2[] = { 2.0, 4.0, 0.0, 4.0 };
   
   static double fxy1[] = { 1.0, 2.0, 3.0, 4.0, 5.0,
                           1.0, 2.0, 3.0, 3.0, 3.0,
                           1.0, 2.0, 3.0, 4.0, 5.0 };
   static double fxy2[] = { 1.0, 2.0, 3.0, 4.0, 5.0,
                            2.0, 2.0, 2.0, 1.0, 1.0,
                            1.0, 2.0, 2.0, 2.0, 3.0 };
   java_pbbser2d(name, time, bb1, 3, 5, fxy1, 2);
   java_pbbser2d(name, time, bb2, 3, 5, fxy2, 2);
}

test_java_cbarser() {
   char *name = "test_java_cbarser";
   double time = 10;
   static double x[] = { 0.0, 1.0, 2.0, 3.0, 4.0, 5.0 };
   static double y[] = { 0.0, 1.0, 2.0, 1.0, 2.0, 3.0 };
   static double w[] = { 0.4, 0.4, 0.4, 0.4, 0.8, 0.4 };
   static double c[] = { 0.0, 1.0, 0.0, 1.0, 0.0, 1.0 };
   java_cbarser(name, time, x, y, w, c, 6);
   
}

test_java_cbarser2() {
   char *name = "test_java_cbarser2";
   double time = 10;
   static double x[] = { 0.0, 1.0, 2.0, 3.0, 4.0, 5.0 };
   static double y[] = { 1.0, 2.0, 1.0, 2.0, 2.5, 2.2 };
   static double w[] = { 0.4, 0.4, 0.8, 0.4, 0.8, 0.4 };
   static double c[] = { 2003.0, 2.0, 3.0, 2.0, 1.0, 3.0 };
   java_cbarser(name, time, x, y, w, c, 6);
   
}


test_java_cbarmser() {
   char *name = "test_java_cbarmser";
   static double time[] = { 1.0, 2.0 };
   static double x[] = { 0.0, 1.0, 2.0, 3.0, 4.0,
                         1.0, 2.0, 3.0, 4.0, 5.0 };
   static double y[] = { 0.0, 1.0, 2.0, 1.0, 2.0, 3.0,
                         1.0, 2.0, 1.0, 2.0, 3.0, 4.0 };
   static double w[] = { 1.0, 1.0, 1.0, 1.0, 0.4, 1.0,
                         1.0, 0.5, 1.0, 1.0, 0.6, 1.0 };
   static double c[] = { 2.0, 2.0, 3.0, 2.0, 2.0, 3.0,
                         1.0, 1.0, 1.0, 1.0, 1.0, 1.0 };
   static int nx[] = { 6, 6 };
   java_cbarmser(name, 2, time, x, y, w, c, nx);
   
}

main() {
  /*
   test_java_ser();
   test_java_mser();
   test_java_cmser();
   test_java_ser2d();
   test_java_mser2d();
   test_java_bser2d();
   test_java_bmser2d();
   test_java_bbser2d();
   test_java_bbmser2d();
   test_java_vser();
   test_java_vmser();
   test_java_bbser();
   test_java_bbmser();
   test_java_pser();
   test_java_pser2d();
   test_java_cbbmser2d();
   test_java_sercon();
   test_java_ebbser();
   test_java_ebbmser();
   test_java_cbarmser();
  */

   test_java_cbarser();
   test_java_cbarser2();
}


